searchNodes=[{"doc":"The Contentful SDK provides helper functions and structs for a subset of the the available Contentful APIs and serves as a container for the shared structs.The available Contentful APIs are:Contentful.Delivery - wraps the Content Delivery API (CDA) - for accessing production ready contentContentful.Preview - wraps the Content Preview API (CPA) - for accessing drafts prepublicationContentful.Management - wraps the Content Management API (CMA) - for managing your contentSetupIn order to add the Contentful SDK add the following to your mix.exs:# mix.exs def deps do [ # your other dependencies, then add: {:contentful, &quot;~&gt; 0.3&quot;} ] endYou can configure your access token(s) and Contentful environments via your local config.exs:# in config.exs config :contentful, json_library: Poison # optional, as Jason is the default # per API definition: config :contentful, delivery: [ space_id: &quot;&lt;my_space_id&gt;&quot;, access_token: &quot;&lt;my_cda_token&gt;&quot;, environment: &quot;&lt;my_environment&gt;&quot; # defaults to `master` ] config :contentful, management: [ coming: :soon ] config :contentful, preview: [ coming: :soon ]Please note that the default json_library that this SDK is tested with is Jason, yet Poison should be compatible.","ref":"Contentful.html","title":"Contentful","type":"module"},{"doc":"The JSON library to use. Can be either configured to Jason or Poison.Examples# in config/config.exs config :contentful, json_library: Jason iex&gt; Contentful.json_library() Jason","ref":"Contentful.html#json_library/0","title":"Contentful.json_library/0","type":"function"},{"doc":"The module provides functions to resolve the Entry &lt;-&gt; Asset relationships.","ref":"Contentful.Entry.AssetResolver.html","title":"Contentful.Entry.AssetResolver","type":"module"},{"doc":"extracts asset ids nested in the fields of a single entry, essentially collecting asset_ids from the tree structure of the entry fields accomodating for serval field types.","ref":"Contentful.Entry.AssetResolver.html#find_linked_asset_ids/1","title":"Contentful.Entry.AssetResolver.find_linked_asset_ids/1","type":"function"},{"doc":"The Contentful Preview API allows the interaction with content that is not yet published and will return assets, entries, etc.It exhibits the same behavior as the Content Delivery API - see Contentful.Delivery.UsageIn order to use it:# in your config.exs config :contentful, delivery: [ endpoint: :preview, space_id: &quot;&lt;my_space_id&gt;&quot;, environment: &quot;&lt;my_environment&gt;&quot;, access_token: &quot;&lt;my_access_token_cpa&gt;&quot; ] you should be able to then use the Contentful.Delivery as a proxy:import Contentful.Query alias Contentful.Delivery, as: Preview {:ok, entry} = Preview.Entries |&gt; fetch_one(&quot;my_entry_id&quot;)You can also pass a custom URL (string) to the :endpoint in config.exs.","ref":"Contentful.Preview.html","title":"Contentful.Preview","type":"module"},{"doc":"The Delivery API is the main access point for fetching data for your customers. The API is read only.If you wish to manipulate data, please have a look at the Contentful.Management.Basic interactionThe space_id, the environment and your access_token can all be configured in config/config.exs:# config/config.exs config :contentful, delivery: [ space_id: &quot;&lt;my_space_id&gt;&quot;, environment: &quot;&lt;my_environment&gt;&quot;, access_token: &quot;&lt;my_access_token_cda&gt;&quot; ]The space can then be fetched as a Contentful.Space via a simple query:import Contentful.Query alias Contentful.Delivery.Spaces {:ok, space} = Spaces |&gt; fetch_oneRetrieving items is then just a matter of importing Contentful.Query:import Contentful.Query alias Contentful.Delivery.Entries {:ok, entries, total: _total_count_of_entries} = Entries |&gt; fetch_allYou can create query chains to form more complex queries:import Contentful.Query alias Contentful.Delivery.Entries {:ok, entries, total: _total_count_of_entries} = Entries |&gt; skip(2) |&gt; limit(10) |&gt; include(2) |&gt; fetch_allFetching indidvidual entities is straight forward:import Contentful.Query alias Contentful.Delivery.Assets my_asset_id = &quot;my_asset_id&quot; {:ok, assets, total: _total_count_of_assets} = Assets |&gt; fetch_one(my_asset_id)All query resolvers also support chaning the space_id, environment and access_token at call time:import Contentful.Query alias Contentful.Delivery.Assets my_asset_id = &quot;my_asset_id&quot; {:ok, asset} = Assets |&gt; fetch_one(my_asset_id)Note: If you want to pass the configuration at call time, you can pass these later as function parameters to the resolver call:import Contentful.Query alias Contentful.Delivery.Assets my_asset_id = &quot;my_asset_id&quot; my_space_id = &quot;bmehzfuz4raf&quot; my_environment = &quot;staging&quot; my_access_token = &quot;not_a_real_token&quot; {:ok, asset} = Assets |&gt; fetch_one(my_asset_id, my_space_id, my_environment, my_access_token) # also works for fetch_all: {:ok, assets, _} = Assets |&gt; fetch_all(my_space_id, my_environment, my_access_token) # and for stream: [ asset | _ ] = Assets |&gt; stream(my_space_id, my_environment, my_access_token) |&gt; Enum.to_list Spaces as an exceptionUnfortunately, Contentful.Delivery.Spaces do not support complete collection behaviour:# doesn&#39;t exist in the Delivery API: {:error, _, _} = Contentful.Delivery.Spaces |&gt; fetch_all # however, you can still retrieve a single `Contentful.Space`: {:ok, space} = Contentful.Delivery.Spaces |&gt; fetch_one # the configured space {:ok, my_space} = Contentful.Delivery.Spaces |&gt; fetch_one(&quot;my_space_id&quot;) # a passed space Further readingContentful Delivery API docs (CDA).","ref":"Contentful.Delivery.html","title":"Contentful.Delivery","type":"module"},{"doc":"Used to make a generic error, in case the API Response is not what is expected","ref":"Contentful.Delivery.html#build_error/0","title":"Contentful.Delivery.build_error/0","type":"function"},{"doc":"Used for the rate limit exceeded error, as it gives the user extra information on wait times","ref":"Contentful.Delivery.html#build_error/1","title":"Contentful.Delivery.build_error/1","type":"function"},{"doc":"Used to construct generic errors for calls against the CDA","ref":"Contentful.Delivery.html#build_error/2","title":"Contentful.Delivery.build_error/2","type":"function"},{"doc":"parses the options for retrieving a collection. It will drop any option that is not in @collection_filters ([:limit, :skip])Examples&quot;?limit=50&amp;skip=25&amp;order=foobar&quot; = collection_query_params(limit: 50, baz: &quot;foo&quot;, skip: 25, order: &quot;foobar&quot;, bar: 42)","ref":"Contentful.Delivery.html#collection_query_params/1","title":"Contentful.Delivery.collection_query_params/1","type":"function"},{"doc":"loads the configuration for the delivery module from the contentful app configuration","ref":"Contentful.Delivery.html#config/0","title":"Contentful.Delivery.config/0","type":"function"},{"doc":"Can be used to retrieve configuration for the Contentful.Delivery moduleExamplesconfig :contentful, delivery: [ my_config: &quot;foobar&quot; ] &quot;foobar&quot; = Contentful.Delivery.config(:my_config)","ref":"Contentful.Delivery.html#config/1","title":"Contentful.Delivery.config/1","type":"function"},{"doc":"Gets the json library for the Contentful Delivery API based on the config/config.exs.","ref":"Contentful.Delivery.html#json_library/0","title":"Contentful.Delivery.json_library/0","type":"function"},{"doc":"catch_all for any errors during flight (connection loss, etc.)","ref":"Contentful.Delivery.html#parse_response/2","title":"Contentful.Delivery.parse_response/2","type":"function"},{"doc":"Builds the request headers for a request against the CDA, taking api access tokens into accountExamplesmy_access_token = &quot;foobarfoob4z&quot; [ &quot;Authorization&quot;: &quot;Bearer foobarfoob4z&quot;, &quot;User-Agent&quot;: &quot;Contentful Elixir SDK&quot;, &quot;Accept&quot;: &quot;application/json&quot; ] = my_access_token |&gt; request_headers()","ref":"Contentful.Delivery.html#request_headers/1","title":"Contentful.Delivery.request_headers/1","type":"function"},{"doc":"Sends a request against the CDA. It's really just a wrapper around HTTPoison.get/2","ref":"Contentful.Delivery.html#send_request/1","title":"Contentful.Delivery.send_request/1","type":"function"},{"doc":"constructs the base url with protocol for the CDAExamples&quot;https://cdn.contentful.com&quot; = url()","ref":"Contentful.Delivery.html#url/0","title":"Contentful.Delivery.url/0","type":"function"},{"doc":"constructs the base url with the extension for a given spaceExamples&quot;https://cdn.contentful.com/spaces/foo&quot; = url(&quot;foo&quot;)","ref":"Contentful.Delivery.html#url/1","title":"Contentful.Delivery.url/1","type":"function"},{"doc":"constructs the base url for the delivery endpoint for a given space and environmentExamples&quot;https://cdn.contentful.com/spaces/foo/environments/bar&quot; = url(&quot;foo&quot;, &quot;bar&quot;)","ref":"Contentful.Delivery.html#url/2","title":"Contentful.Delivery.url/2","type":"function"},{"doc":"This module provides the chainable query syntax for building queries against the APIs of Contentful.The chains will then be serialized to a URL and send to the API. A basic query looks like this:Entity |&gt; skip(3) |&gt; limit(2) |&gt; fetch_allwherein Entity is one of the modules that exhibit Contentful.Queryable behaviour, such as Contentful.Delivery.Entries, Contentful.Delivery.Assets and Contentful.Delivery.ContentTypes.As an example, querying all entries of a given Contentful.Space (represented by its space_id) can be done as follows:Contentful.Delivery.Entries |&gt; Contentful.Query.fetch_all(space_id)","ref":"Contentful.Query.html","title":"Contentful.Query","type":"module"},{"doc":"adds a content_type parameter for filtering sets of Contentful.Entry by a Contentful.ContentType, effectively allowing for scoping by content type.content_type will only work with Contentful.Delivery.Entries at the moment.Examplesalias Contentful.Delivery.Entries Entries |&gt; content_type(&quot;foobar&quot;) |&gt; fetch_all # translates in the background to &quot;&lt;api_url&gt;/entries?content_type=foobar&quot; # also works with passing `Contentful.ContentType`: my_content_type = %Contentful.ContentType{sys: %Contentful.SysData{id: &quot;foobar&quot;}} Entries |&gt; content_type(my_content_type) |&gt; fetch_all","ref":"Contentful.Query.html#content_type/2","title":"Contentful.Query.content_type/2","type":"function"},{"doc":"will resolve a query chain by eagerly calling the API and resolving the response immediatelyExamplesalias Contentful.Delivery.Entries {:ok, entries, total: _total_count_of_entries} = Entries |&gt; content_type(&quot;foobar&quot;) |&gt; limit(1) |&gt; fetch_all","ref":"Contentful.Query.html#fetch_all/4","title":"Contentful.Query.fetch_all/4","type":"function"},{"doc":"will resolve a query chain by eagerly calling the API asking for one entityExamplesimport Contentful.Query alias Contentful.Delivery.{Spaces, Entries} # Note: Spaces is the only Queryable that can be fetched without an id Spaces |&gt; fetch_one # all others would throw an error, so an id has to be passed: Entries |&gt; fetch_one(&quot;my_entry_id&quot;)","ref":"Contentful.Query.html#fetch_one/5","title":"Contentful.Query.fetch_one/5","type":"function"},{"doc":"adds the include parameter to a query.This allows for fetching associated items up to a collection of Contentful.Entry.The include call will only work with Contentful.Delivery.Entries, as it is meaningless to other entities.Example:alias Contentful.Delivery.Entries Entries |&gt; include(2) |&gt; fetch_all # translates in the background to &quot;&lt;api_url&gt;/entries?include=2&quot;","ref":"Contentful.Query.html#include/2","title":"Contentful.Query.include/2","type":"function"},{"doc":"adds the limit parameter to a call, limiting the amount of entities returned. The caller will still retreive the total amount of entities, if successful.The limit defaults to 1000, the maximum limit allowed for API calls.Examplesalias Contentful.Delivery.Assets Assets |&gt; limit(2) |&gt; fetch_all # translates in the background to &quot;&lt;api_url&gt;/assets?limit=2&quot;","ref":"Contentful.Query.html#limit/2","title":"Contentful.Query.limit/2","type":"function"},{"doc":"adds the skip parameter to API calls, allowing to skip over a number of entities, effectively allowing the implementation of pagination if desired.Examplesalias Contentful.Delivery.Assets Assets |&gt; skip(10) |&gt; fetch_all # translates in the background to a call to the API &quot;&lt;api_url&gt;/assets?skip=10&quot;","ref":"Contentful.Query.html#skip/2","title":"Contentful.Query.skip/2","type":"function"},{"doc":"will resolve a query chain by constructing a Stream.resource around a possible API response allowing for lazy evaluation of queries. Cann be helpful with translating collection calls of unknown size.Be careful when using this, as one can run into API rate limits quickly for very large sets.Examplesimport Contentful.Query alias Contentful.Delivery.{Assets, Spaces} # translates into two api calls in the background Assets |&gt; stream |&gt; Enum.take(2000) # you can use limit() to set the page size, in the example, stream would call the API # 10 times total. Assets |&gt; limit(100) |&gt; Enum.take(1000) # will not work with Spaces, though, as they","ref":"Contentful.Query.html#stream/4","title":"Contentful.Query.stream/4","type":"function"},{"doc":"This module extracts the stream functionality from the Contentful.Query providing the underlying functions for the streaming functionality of collectable entities from the Contentful API.","ref":"Contentful.Stream.html","title":"Contentful.Stream","type":"module"},{"doc":"Entrypoint for constructing a stream, see Contentful.Query.stream/4.","ref":"Contentful.Stream.html#stream/4","title":"Contentful.Stream.stream/4","type":"function"},{"doc":"Deals with the loading of assets from a given Contentful.SpaceSee https://www.contentful.com/developers/docs/references/content-delivery-api/#/reference/assets.endSimple asset callsA Contentful.Asset can be retrieved by its asset_id: import Contentful.Query alias Contentful.Asset alias Contentful.Delivery.Assets} = Assets |&gt; fetch_one(&quot;my_asset_id&quot;)or just as a collection: import Contentful.Query alias Contentful.Asset alias Contentful.Delivery.Assets | _ ]} = Assets |&gt; fetch_allResolving assets from entriesIn the case of inclusion of assets with entries, see the docs for Contentful.Entries to see how to resolve assets from entries.Accessing common resource attributesA Contentful.Asset embeds Contentful.SysData with extra information about the entry: import Contentful.Query alias Contentful.Asset alias Contentful.Delivery.Assets = Assets |&gt; fetch_one(&quot;my_asset_id&quot;) &quot;my_asset_id&quot; = asset.id &quot;&lt;a timestamp for updated_at&gt;&quot; = asset.sys.updated_at &quot;&lt;a timestamp for created_at&gt;&quot; = asset.sys.created_at &quot;&lt;a locale string&gt;&quot; = asset.sys.locale","ref":"Contentful.Delivery.Assets.html","title":"Contentful.Delivery.Assets","type":"module"},{"doc":"Returns the endpoint for assets","ref":"Contentful.Delivery.Assets.html#endpoint/0","title":"Contentful.Delivery.Assets.endpoint/0","type":"function"},{"doc":"Provides functions around reading content types from a given Contentful.SpaceSee https://www.contentful.com/developers/docs/references/content-delivery-api/#/reference/content-types/content-typeSimple callsFetching a single content type is straight forward: import Contentful.Query alias Contentful.ContentType alias Contentful.Delivery.ContentTypes} = ContentTypes |&gt; fetch_one(&quot;my_content_type_id&quot;)Fetching multiple content types is also possible: import Contentful.Query alias Contentful.ContentType alias Contentful.Delivery.ContentTypes | _ ]} = ContentTypes |&gt; fetch_allAccessing common resource attributesA Contentful.ContentType embeds Contentful.SysData with extra information about the entry: import Contentful.Query alias Contentful.ContentType alias Contentful.Delivery.ContentTypes = ContentTypes |&gt; fetch_one(&quot;my_content_type_id&quot;) &quot;my_content_type_id&quot; = content_type.id &quot;&lt;a timestamp for updated_at&gt;&quot; = content_type.sys.updated_at &quot;&lt;a timestamp for created_at&gt;&quot; = content_type.sys.created_at","ref":"Contentful.Delivery.ContentTypes.html","title":"Contentful.Delivery.ContentTypes","type":"module"},{"doc":"Entries allows for querying the entries of a space via Contentful.Query.Fetching a single entryimport Contentful.Query alias Contentful.Delivery.Entries {:ok, entry} = Entries |&gt; fetch_one(&quot;my_entry_id&quot;)Simple querying of a collection of entriesimport Contentful.Query alias Contentful.Delivery.Entries # fetches the entries based on the `space_id`, `environment` and `access_token` in config/config.exs {:ok, entries, total: _total_count_of_entries} = Entries |&gt; fetch_all # fetches the entries by passing `space_id`, `environment` and `access_token` space_id = &quot;&lt;my_space_id&gt;&quot; environment = &quot;&lt;my_environment&gt;&quot; access_token = &quot;&lt;my_access_token&gt;&quot; {:ok, entries, total: _total_count_of_entries} = Entries |&gt; fetch_all(space_id, environment, access_token)More advanced query with included assetsEntries can have assets included, which limits the amount of times a client has to request data from the server:import Contentful.Query alias Contentful.{Asset, Entry} alias Contentful.Delivery.Entries # The default include depth is 1 (max 10) {:ok, [ %Entry{assets: assets} = entry | _ ], total: _total_count_of_entries} = Entries |&gt; include |&gt; fetch_all assets |&gt; Enum.map(fn %Asset{fields: fields} -&gt; {fields.title, fields.file} end) # you can also just get the assets belonging to an entry lazily: Entries |&gt; include |&gt; stream |&gt; Stream.flat_map(fn entry -&gt; entry.assets end) |&gt; Enum.take(2)Accessing common resource attributesEntries embed Contentful.SysData with extra information about the entry: import Contentful.Query alias Contentful.{ContentType, Entry, SysData} alias Contentful.Delivery.Entries = Entries |&gt; fetch_one(&quot;my_entry_id&quot;) &quot;my_entry_id&quot; = entry.id &quot;&lt;a timestamp for updated_at&gt;&quot; = entry.sys.updated_at &quot;&lt;a timestamp for created_at&gt;&quot; = entry.sys.created_at &quot;&lt;a locale string&gt;&quot; = entry.sys.locale %ContentType{id: &quot;the_associated_content_type_id&quot;} = entry.sys.content_type","ref":"Contentful.Delivery.Entries.html","title":"Contentful.Delivery.Entries","type":"module"},{"doc":"maps a standard API response for queries compliant with the Contentful.Queryable behaviour.","ref":"Contentful.Delivery.Entries.html#resolve_collection_response/1","title":"Contentful.Delivery.Entries.resolve_collection_response/1","type":"function"},{"doc":"maps a standard API response for a single entry returned, compliant with the Contentful.Queryable behaviour.","ref":"Contentful.Delivery.Entries.html#resolve_entity_response/1","title":"Contentful.Delivery.Entries.resolve_entity_response/1","type":"function"},{"doc":"Handles the fetching of locales within a given Contentful.Space","ref":"Contentful.Delivery.Locales.html","title":"Contentful.Delivery.Locales","type":"module"},{"doc":"Spaces provides function related to the reading of spaces through the Contentful Delivery API","ref":"Contentful.Delivery.Spaces.html","title":"Contentful.Delivery.Spaces","type":"module"},{"doc":"Represents an asset available within a Contentful.Space.https://www.contentful.com/developers/docs/references/content-delivery-api/#/reference/assets","ref":"Contentful.Asset.html","title":"Contentful.Asset","type":"module"},{"doc":"","ref":"Contentful.Asset.html#t:t/0","title":"Contentful.Asset.t/0","type":"type"},{"doc":"Represents the fields of a Contentful.Asset, which can very depending on the Contentful.Asset.","ref":"Contentful.Asset.Fields.html","title":"Contentful.Asset.Fields","type":"module"},{"doc":"","ref":"Contentful.Asset.Fields.html#t:t/0","title":"Contentful.Asset.Fields.t/0","type":"type"},{"doc":"Describes functions around ContentTypes in a Contentful.SpaceSee the official docs for more information.","ref":"Contentful.ContentType.html","title":"Contentful.ContentType","type":"module"},{"doc":"returns the display field for a given content typeExamplescontent_type = %ContentType{display_field: &quot;name&quot;, fields: [%ContentType.Field{name: &quot;name&quot;}]} # extracts the display field from the content type %ContentType.Field{name: &quot;name&quot;} = content_type |&gt; ContentType.display_field","ref":"Contentful.ContentType.html#display_field/1","title":"Contentful.ContentType.display_field/1","type":"function"},{"doc":"A ContentType is part of the content model defined in a space","ref":"Contentful.ContentType.html#t:t/0","title":"Contentful.ContentType.t/0","type":"type"},{"doc":"Represents a single field in the field defintion of a Contentful.ContentType.See the content model documentation for more information","ref":"Contentful.ContentType.Field.html","title":"Contentful.ContentType.Field","type":"module"},{"doc":"","ref":"Contentful.ContentType.Field.html#t:t/0","title":"Contentful.ContentType.Field.t/0","type":"type"},{"doc":"An entry is a representation of anything that can be expressed as a defined content type within a given Contentful.Space.See the official documentation for more information.","ref":"Contentful.Entry.html","title":"Contentful.Entry","type":"module"},{"doc":"","ref":"Contentful.Entry.html#t:t/0","title":"Contentful.Entry.t/0","type":"type"},{"doc":"Represents a single locale available in a given Space - seeSee the official docs for more information","ref":"Contentful.Locale.html","title":"Contentful.Locale","type":"module"},{"doc":"","ref":"Contentful.Locale.html#t:t/0","title":"Contentful.Locale.t/0","type":"type"},{"doc":"A Space represents a space on contentful, holding most of the objects you work with, e.g. Contentful.Asset, Contentful.Entry or Contentful.LocaleSee the official documentation for more information","ref":"Contentful.Space.html","title":"Contentful.Space","type":"module"},{"doc":"","ref":"Contentful.Space.html#t:t/0","title":"Contentful.Space.t/0","type":"type"},{"doc":"The SysData represents internal additional data for Contentful API objects, usually found in the &quot;sys&quot; part of the response objects. It's also referred to as &quot;common properties&quot;.See the official documentation for more information.","ref":"Contentful.SysData.html","title":"Contentful.SysData","type":"module"},{"doc":"","ref":"Contentful.SysData.html#t:t/0","title":"Contentful.SysData.t/0","type":"type"},{"doc":"Behaviour for allowing another module to be processed by the functions of Contentful.Query.See also:Contentful.Delivery.AssetsContentful.Delivery.ContentTypesContentful.Delivery.EntriesContentful.Delivery.LocalesContentful.Delivery.Spaces","ref":"Contentful.Queryable.html","title":"Contentful.Queryable","type":"behaviour"},{"doc":"","ref":"Contentful.Queryable.html#c:endpoint/0","title":"Contentful.Queryable.endpoint/0","type":"callback"},{"doc":"","ref":"Contentful.Queryable.html#c:resolve_collection_response/1","title":"Contentful.Queryable.resolve_collection_response/1","type":"callback"},{"doc":"","ref":"Contentful.Queryable.html#c:resolve_entity_response/1","title":"Contentful.Queryable.resolve_entity_response/1","type":"callback"}]